'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropdownContent = exports.DropdownTrigger = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMinimalistPortal = require('react-minimalist-portal');

var _reactMinimalistPortal2 = _interopRequireDefault(_reactMinimalistPortal);

var _dropdownTrigger = require('./dropdown-trigger');

var _dropdownTrigger2 = _interopRequireDefault(_dropdownTrigger);

var _dropdownContent = require('./dropdown-content');

var _dropdownContent2 = _interopRequireDefault(_dropdownContent);

var _dom = require('../utils/dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_Component) {
  _inherits(Dropdown, _Component);

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._watchClicks();

      if (this.props.attachment === 'attached' && this.isActive()) {
        this._startAutoUpdateContentStyle();
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      var wasActive = this.props.active || this.state.active;
      var willBeActive = nextProps.active || nextState.active;

      if (!wasActive && willBeActive && nextProps.attachment === 'attached' || willBeActive && nextProps.attachment === 'attached' && this.props.attachment !== 'attached') {
        this._startAutoUpdateContentStyle();
      }

      if (wasActive && !willBeActive || nextProps.attachment !== 'attached' && this.props.attachment === 'attached') {
        this._stopAutoUpdateContentStyle();
      }

      if (!wasActive && willBeActive) {
        this._setContentStyle();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._unwatchClicks();
      this._stopAutoUpdateContentStyle();
    }
  }]);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Dropdown).call(this, props));

    _this.state = {
      active: false
    };

    _this._onWindowClick = _this._onWindowClick.bind(_this);
    _this._onToggleClick = _this._onToggleClick.bind(_this);
    _this._onAnimationFrame = _this._onAnimationFrame.bind(_this);
    _this._setContentStyle = _this._setContentStyle.bind(_this);
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'isActive',
    value: function isActive() {
      return typeof this.props.active === 'boolean' ? this.props.active : this.state.active;
    }
  }, {
    key: 'hide',
    value: function hide() {
      var _this2 = this;

      this.setState({
        active: false
      }, function () {
        if (_this2.props.onHide) {
          _this2.props.onHide();
        }
      });
    }
  }, {
    key: 'show',
    value: function show() {
      var _this3 = this;

      this.setState({
        active: true
      }, function () {
        _this3._setContentStyle();
        if (_this3.props.onShow) {
          _this3.props.onShow();
        }
      });
    }
  }, {
    key: '_watchClicks',
    value: function _watchClicks() {
      window.addEventListener('click', this._onWindowClick);
      window.addEventListener('touchstart', this._onWindowClick);
    }
  }, {
    key: '_unwatchClicks',
    value: function _unwatchClicks() {
      window.removeEventListener('click', this._onWindowClick);
      window.removeEventListener('touchstart', this._onWindowClick);
    }
  }, {
    key: '_startAutoUpdateContentStyle',
    value: function _startAutoUpdateContentStyle() {
      if (!this._contentStyleUpdaterRafId) {
        this._contentStyleUpdaterRafId = requestAnimationFrame(this._onAnimationFrame);
      }
    }
  }, {
    key: '_stopAutoUpdateContentStyle',
    value: function _stopAutoUpdateContentStyle() {
      if (this._contentStyleUpdaterRafId) {
        cancelAnimationFrame(this._contentStyleUpdaterRafId);
        delete this._contentStyleUpdaterRafId;
      }
    }
  }, {
    key: '_onAnimationFrame',
    value: function _onAnimationFrame() {
      var attachment = this.props.attachment;


      if (attachment !== 'attached') {
        return;
      }

      this._setContentStyle();
      this._contentStyleUpdaterRafId = requestAnimationFrame(this._onAnimationFrame);
    }
  }, {
    key: '_onWindowClick',
    value: function _onWindowClick(event) {
      if (!this.refs.content) {
        return;
      }

      var dropdownContentElement = this.refs.content.getElement();
      var dropdownTriggerElement = this.refs.trigger.getElement();
      var isInContent = event.target === dropdownContentElement || dropdownContentElement.contains(event.target);
      var isInTrigger = event.target === dropdownTriggerElement || dropdownTriggerElement.contains(event.target);

      if (!isInContent && !isInTrigger && this.isActive()) {
        this.hide();
      }
    }
  }, {
    key: '_onToggleClick',
    value: function _onToggleClick(event) {
      event.preventDefault();
      if (this.isActive()) {
        this.hide();
      } else {
        this.show();
      }
    }
  }, {
    key: '_setContentStyle',
    value: function _setContentStyle() {
      if (!this.refs.content) {
        return;
      }

      var _props = this.props;
      var avoidEdges = _props.avoidEdges;
      var contentHorizontalEdge = _props.contentHorizontalEdge;
      var contentVerticalEdge = _props.contentVerticalEdge;
      var positionHorizontal = _props.positionHorizontal;
      var positionVertical = _props.positionVertical;

      var triggerPosition = this.refs.trigger.getElement().getBoundingClientRect();
      var contentElement = this.refs.content.getElement();
      var contentHeight = (0, _dom.getElementOuterHeight)(contentElement);
      var contentWidth = (0, _dom.getElementOuterWidth)(contentElement);
      var horizontalOffset = window.scrollX;
      var verticalOffset = window.scrollY;

      if (triggerPosition) {
        horizontalOffset += triggerPosition.left;
        verticalOffset += triggerPosition.top;

        if (positionHorizontal === 'center') {
          horizontalOffset += triggerPosition.width / 2;
        } else if (positionHorizontal === 'right') {
          horizontalOffset += triggerPosition.width;
        }

        if (positionVertical === 'bottom') {
          verticalOffset += triggerPosition.height;
        } else if (positionVertical === 'middle') {
          verticalOffset += triggerPosition.height / 2;
        }
      }

      if (contentVerticalEdge === 'bottom') {
        verticalOffset -= contentHeight;
      } else if (contentVerticalEdge === 'middle') {
        verticalOffset -= contentHeight / 2;
      }

      if (contentHorizontalEdge === 'right') {
        horizontalOffset -= contentWidth;
      } else if (contentHorizontalEdge === 'center') {
        horizontalOffset -= contentWidth / 2;
      }

      if (avoidEdges) {
        var contentTopEdge = verticalOffset;
        var contentRightEdge = horizontalOffset + contentWidth;
        var contentBottomEdge = verticalOffset + contentHeight;
        var contentLeftEdge = horizontalOffset;

        var windowTopEdge = window.scrollY;
        var windowRightEdge = window.scrollX + window.innerWidth;
        var windowBottomEdge = window.scrollY + window.innerHeight;
        var windowLeftEdge = window.scrollX;

        var beyondTopEdge = contentTopEdge < windowTopEdge;
        var beyondRightEdge = contentRightEdge > windowRightEdge;
        var beyondBottomEdge = contentBottomEdge > windowBottomEdge;
        var beyondLeftEdge = contentLeftEdge < windowLeftEdge;

        if (beyondBottomEdge) {
          verticalOffset = windowBottomEdge - 5 - contentHeight;
        } else if (beyondTopEdge) {
          verticalOffset = windowTopEdge + 5;
        }

        if (beyondLeftEdge) {
          horizontalOffset = windowLeftEdge + 5;
        } else if (beyondRightEdge) {
          horizontalOffset = windowRightEdge - 5 - contentWidth;
        }
      }

      this.setState({
        contentStyle: {
          position: 'absolute',
          top: 0,
          left: 0,
          transform: 'translateX(' + horizontalOffset + 'px) translateY(' + verticalOffset + 'px)'
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this,
          _arguments = arguments;

      var _props2 = this.props;
      var attachment = _props2.attachment;
      var children = _props2.children;
      var className = _props2.className;
      var disabled = _props2.disabled;
      var removeElement = _props2.removeElement;
      // create component classes

      var active = this.isActive();
      var renderInPortal = attachment === 'detached' || attachment === 'attached';
      var dropdownClasses = (0, _classnames2.default)({
        dropdown: true,
        'dropdown--active': active,
        'dropdown--disabled': disabled
      });
      // stick callback on trigger element
      var boundChildren = _react2.default.Children.map(children, function (child) {
        if (child.type === _dropdownTrigger2.default) {
          (function () {
            var originalOnClick = child.props.onClick;
            child = (0, _react.cloneElement)(child, {
              ref: 'trigger',
              onClick: function onClick(event) {
                if (!disabled) {
                  _this4._onToggleClick(event);
                  if (originalOnClick) {
                    originalOnClick.apply(child, _arguments);
                  }
                }
              }
            });
          })();
        } else if (child.type === _dropdownContent2.default) {
          if (removeElement && !active) {
            child = null;
          } else if (renderInPortal) {
            var _state$contentStyle = _this4.state.contentStyle;
            var contentStyle = _state$contentStyle === undefined ? {
              visibility: 'hidden'
            } : _state$contentStyle;


            child = (0, _react.cloneElement)(child, {
              ref: 'content',
              active: active,
              style: contentStyle
            });

            child = _react2.default.createElement(
              _reactMinimalistPortal2.default,
              null,
              child
            );
          } else {
            child = (0, _react.cloneElement)(child, {
              ref: 'content',
              active: active
            });
          }
        }
        return child;
      });
      var cleanProps = _extends({}, this.props);
      delete cleanProps.attachment;
      delete cleanProps.avoidEdges;
      delete cleanProps.active;
      delete cleanProps.contentHorizontalEdge;
      delete cleanProps.contentVerticalEdge;
      delete cleanProps.onShow;
      delete cleanProps.onHide;
      delete cleanProps.positionHorizontal;
      delete cleanProps.positionVertical;
      delete cleanProps.removeElement;

      return _react2.default.createElement(
        'div',
        _extends({}, cleanProps, {
          className: dropdownClasses + ' ' + className }),
        boundChildren
      );
    }
  }]);

  return Dropdown;
}(_react.Component);

Dropdown.propTypes = {
  attachment: _propTypes2.default.oneOf(['attached', 'detached', 'inline']),
  avoidEdges: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  active: _propTypes2.default.bool,
  onHide: _propTypes2.default.func,
  onShow: _propTypes2.default.func,
  positionHorizontal: _propTypes2.default.oneOf(['left', 'center', 'right']),
  positionVertical: _propTypes2.default.oneOf(['top', 'middle', 'bottom']),
  contentHorizontalEdge: _propTypes2.default.oneOf(['left', 'center', 'right']),
  contentVerticalEdge: _propTypes2.default.oneOf(['top', 'middle', 'bottom']),
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  removeElement: _propTypes2.default.bool,
  style: _propTypes2.default.object
};

Dropdown.defaultProps = {
  attachment: 'attached',
  avoidEdges: true,
  contentHorizontalEdge: 'left',
  contentVerticalEdge: 'top',
  className: '',
  positionHorizontal: 'left',
  positionVertical: 'bottom'
};

exports.DropdownTrigger = _dropdownTrigger2.default;
exports.DropdownContent = _dropdownContent2.default;
exports.default = Dropdown;