'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pixelStringToInteger = pixelStringToInteger;
exports.getElementOuterHeight = getElementOuterHeight;
exports.getElementOuterWidth = getElementOuterWidth;
function pixelStringToInteger(marginString) {
  return parseInt((marginString || '').replace('px', ''), 10) || 0;
}

function getElementOuterHeight(element) {
  var height = element.offsetHeight || element.outerHeight;
  var styles = window.getComputedStyle(element);
  var verticalMargin = pixelStringToInteger(styles['margin-top']) + pixelStringToInteger(styles['margin-bottom']);

  return height + verticalMargin;
}

function getElementOuterWidth(element) {
  var width = element.offsetWidth || element.outerWidth;
  var styles = window.getComputedStyle(element);
  var horizontalMargin = pixelStringToInteger(styles['margin-left']) + pixelStringToInteger(styles['margin-right']);

  return width + horizontalMargin;
}